import { render } from "react-dom";
import { browserHistory } from "react-router";
import { LOCATION_CHANGE, syncHistoryWithStore, routerMiddleware } from "react-router-redux";
import { combineReducers } from "redux-immutable";
import * as Immutable from "immutable";
import getRoot from "./containers/root";
import configureStore from "./store/configure_store";
const initialRouterReducerState = Immutable.fromJS({
    locationBeforeTransitions: null
});
let routerReducer = (state = initialRouterReducerState, action) => {
    if (action.type === LOCATION_CHANGE) {
        return state.merge({
            locationBeforeTransitions: action.payload
        });
    }
    return state;
};
function bootstrap(options) {
    if (options === undefined) {
        throw new TypeError("Null argument options.");
    }
    ;
    if (options.routes === undefined) {
        throw new TypeError("Invalid configuration field: routes.");
    }
    ;
    if (options.reducers === undefined) {
        throw new TypeError("Invalid configuration field: reducers.");
    }
    ;
    let routes = options.routes;
    let reducers = options.reducers;
    let container = options.container || "root";
    let initialState = options.initialState || {};
    let immutableInitialState = Immutable.fromJS(initialState);
    let middlewares = options.middlewares || [];
    reducers.routing = routerReducer;
    let rootReducer = combineReducers(reducers);
    let routerMddlwr = routerMiddleware(browserHistory);
    const store = configureStore([...middlewares, routerMddlwr], rootReducer, immutableInitialState);
    const history = syncHistoryWithStore(browserHistory, store, {
        selectLocationState: (state) => state.get("routing").toJS()
    });
    render(getRoot(store, history, routes), document.getElementById(container));
    return store;
}
export default bootstrap;
